#include <stdio.h>
#include <fract.h>
#include <filter.h>

#define	NUM_VEC		10	// pocet spracovavanych blokov
#define VEC_SIZE 	256	// velkost spracovavaneho bloku
#define NUM_TAPS 	122	// pocet koeficientov FIR filtra




fir_state_fr16 state;	// declare filter state

fract16 in[VEC_SIZE];
fract16 out[VEC_SIZE];


FILE *inFile, *outFile;

static segment("L1_data_b")
fract16 coefs[NUM_TAPS] = {
#include "coefs.h"		// subor s koeficientmi FIR filtra
};

static segment("L1_data_a")
fract16 delay[NUM_TAPS];

int readInput(short *inBuf,int count)
{
	int wordsRead=0;

	wordsRead = fread(inBuf,sizeof(short),count,inFile);

	return wordsRead;

}

int writeOutput(short *outBuf,int count)
{
	int wordsRead=0;

	wordsRead = fwrite(outBuf,sizeof(short),count,outFile);

	return wordsRead;

}

void main( void )
{
	int i;

   	inFile = fopen("D:\\Users\\SPVT\\x.dat","rb");
   	outFile = fopen("D:\\Users\\SPVT\\y.dat","wb");

   	fir_init(state, coefs, delay, NUM_TAPS, 1);	// inicializacia stavu filtra

   	i = NUM_VEC;
   	while( i-- ) {
    	readInput(in, VEC_SIZE);                // nacitanie vstupneho bloku
	    fir_fr16(in, out, VEC_SIZE, &state);	// filtracia vstupneho bloku
   		writeOutput(out,VEC_SIZE);    	        // zapis vystupneho bloku
   	}

  	fclose( inFile );
   	fclose( outFile );

//	while( 1 )									// nekonecna slucka
   		;
}


